Unit IA10R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, IA10R1_p, IAC1R1_p, IAS1R2_p;

procedure IA10R(FUNX :Func_F1; AX :Real; BX :Real; EPS :Real;
                LX :Integer; IDX :Integer; JX :Integer;
                NXM :Integer; var NX :Integer;
                var TX :Array of Real; var CX :Array of Real);

implementation

procedure IA10R(FUNX :Func_F1; AX :Real; BX :Real; EPS :Real;
                LX :Integer; IDX :Integer; JX :Integer;
                NXM :Integer; var NX :Integer;
                var TX :Array of Real; var CX :Array of Real);
var
I,J,K,KX,L :Integer;
A :Real;
const
C0 :Real = 0.0;
K1 :Integer = 1;
K2 :Integer = 2;
label
_10,_20,_30,_40;
begin
KX  := K2*(LX + K2);
I  := NX + K2*(KX - K2);
A  := (BX - AX)/(NX - K1);
for J:=K1 to I do
 begin
  TX[J-1] := AX + (J - KX + K1)*A;
  CX[J-1] := FUNX(TX[J-1]);
_10:
 end;
I  := NX + KX - K2;
J  := LX + K1;
for K:=K1 to I do
 begin
  L  := K + J;
  CX[K-1] := IAC1R1(TX,CX,J,L);
_20:
 end;
I  := KX - K2;
for J:=K1 to NX do
 begin
  K  := I + J;
  L  := K;
  if ( J  =  NX )
   then L  := L - K1;
  CX[J-1] := IAS1R2(TX,CX,KX,I,TX[K-1],L,K1);
  if ( CX[J-1] <  C0 )
   then CX[J-1] := C0 - CX[J-1];
_30:
 end;
IA10R1(CX,NX,AX,BX,EPS,NXM,KX,IDX,JX,TX);
KX  := K2*K2;
I  := NX + K2;
CX[K1-1] := FUNX(TX[K1-1]);
CX[K2-1] := FUNX(TX[K2-1]);
for J:=K1 to I do
 begin
  K  := J + K2;
  CX[K-1] := FUNX(TX[K-1]);
  K  := K - K1;
  CX[J-1] := IAC1R1(TX,CX,LX,K);
_40:
 end;
end;

end.
